#!/usr/bin/env python
"""
Duskers Quicksaver Housekeeping Update, Sep 3, 2019.
Tested with Steam copy v 1.041
Use at your own risk

User Instructions
1. Create a dedicated folder for quicksave files and duskers-quicksaver.py
2. Open any kind of text editors and copy the following scripts:
	macOS/Linux
		#!/bin/bash
		cd "$(dirname "$0")"
		python duskers-quicksaver.py
	Windows
		python duskers-quicksaver.py
		pause
3. Save the file as following name:
	macOS/Linux
		start.command
	Windows
		start.bat
4. Simply click on the start file and the quicksaver will launch.

Made by Rian Gray (r26gray at gmail.com).
Published on The Mad Tea Party (www.themtparty.com).
"""

#Path to save files on each platform
WindowsSavePath = '~/Documents/My Games/Duskers/'
MacSavePath = '~/Library/Application Support/unity.Misfits Attic.Duskers'
LinuxSavePath = 'Home/.config/unity3d/Misfits Attic/Duskers'

import os
#Use current path as the save target path
TargetPath = os.getcwd() + '/'

import sys
import getopt
import shutil
import time
import datetime
import platform
from distutils import dir_util

#save from source
def save(SourcePath, TargetPath):
	dir_util.copy_tree(SourcePath, TargetPath)
	return

#restore from target
def restore(SourcePath, TargetPath):
	dir_util.copy_tree(TargetPath, SourcePath)
	return

def main():
	#platform tester; Mac, Windows, Linux, and manual
	if platform.system() == 'Darwin':
		print 'Detected: macOS ', platform.mac_ver()[0]
		SourcePath = os.path.expanduser(MacSavePath)
	elif platform.system() == 'Windows':
		print 'Detected: Windows ', platform.win32_ver()[0]
		SourcePath = os.path.expanduser(WindowsSavePath)
	elif platform.system() == 'Linux':
		print 'Deteced: Linux ', platform.linux_distribution()[0]
		SourcePath = os.path.expanduser(LinuxSavePath)
	else:
		print 'Detection Error: Could not find OS information.'
		SourcePath = raw_input("Please manually locate the save files: \n")

	#loop for quicksave
	while 1:
		input = raw_input("Press 1 to [S]ave, Press 2 to [L]oad, Press 3 to [Q]uit:\n").lower()
		now = time.strftime('%I:%M %p')
		if input in ('1', 's'):
			save(SourcePath, TargetPath)
			print "Saved: ", now
		elif input in ('2', 'l'):
			restore(SourcePath, TargetPath)
			print "Restored: ", now
		elif input in ('3', 'q'):
			break
		elif input in ('c', 't'):
			print "Current Time: ", now
		else:
			print "Input Error: Please try again."

if __name__=="__main__":
	main()